// ColTrees.h (2007.3.25)

// Փ˔pc[NX錾

// C
// 2007. 5. 13
//  2̋ʋԂZo鎞ɈZĂoO
//  rI_aɕύX

#pragma once

#include <windows.h>
#include <set>
#include "SmartPtr.h"
#include <vector>
#include <list>
#include <map>

using namespace std;


namespace IKD
{


template <class T>
class CCell;
/////////////////////////////////////
// ؓo^IuWFNg(OFT)
//////////////////////////////////
template< class T>
class OBJECT_FOR_TREE
{
public:
	CCell<T> *m_pCell;			// o^
	T *m_pObject;				// ΏۃIuWFNg
	sp<OBJECT_FOR_TREE<T> > m_spPre;	// OOBJECT_FOR_TREE\
	sp<OBJECT_FOR_TREE<T> > m_spNext;	// OBJECT_FOR_TREE\

public:
	OBJECT_FOR_TREE(){
		m_pCell = NULL;
		m_pObject = NULL;
	}

	virtual ~OBJECT_FOR_TREE()
	{
	}

public:
	// 烊XgO
	bool Remove(){
		// łɈEĂ鎞͏I
		if(!m_pCell)
			return false;

		// o^ĂԂɎgʒm
		if(!m_pCell->OnRemove( this ))
			return false;

		// E
		// ÕIuWFNgт
		if(m_spPre.GetPtr() != NULL)
		{
			m_spPre->m_spNext = m_spNext;
			m_spPre.SetPtr(NULL);
		}
		if(m_spNext.GetPtr() != NULL )
		{
			m_spNext->m_spPre = m_spPre;
			m_spNext.SetPtr(NULL);
		}
		m_pCell = NULL;
		return true;
	}

	// Ԃo^
	void RegistCell( CCell<T> *pCell )
	{
		m_pCell = pCell;
	}

	// ̃IuWFNgւ̃X}[g|C^擾
	sp<OBJECT_FOR_TREE<T> > &GetNextObj(){
		return m_spNext;
	}
};



/////////////////////////////////////
// `4؋ԊǗNX
//////////////////////////////////
#define CLINER4TREEMANAGER_MAXLEVEL		9
template <class T>
class CLiner4TreeManager
{
protected:
	unsigned int m_uiDim;
	CCell<T> **ppCellAry;	// `ԃ|C^z
	unsigned int m_iPow[CLINER4TREEMANAGER_MAXLEVEL+1];	// ׂ搔lz
	float m_fW;		// ̈X
	float m_fH;		// ̈Y
	float m_fLeft;	// ̈̍iXŏlj
	float m_fTop;	// ̈̏㑤iYŏlj
	float m_fUnit_W;		// ŏxԂ̕P
	float m_fUnit_H;		// ŏxԂ̍P
	DWORD m_dwCellNum;		// Ԃ̐
	unsigned int m_uiLevel;			// ŉʃx

public:
	// RXgN^
	CLiner4TreeManager()
	{
		m_uiLevel = 0;
		m_fW = 0.0f;
		m_fH = 0.0f;
		m_fLeft = 0.0f;
		m_fTop = 0.0f;
		m_fUnit_W = 0.0f;
		m_fUnit_H = 0.0f;
		m_dwCellNum = 0;
		ppCellAry = NULL;
		m_uiDim = 0;
	}

	// fXgN^
	virtual ~CLiner4TreeManager()
	{
		DWORD i;
		for(i=0; i<m_dwCellNum; i++){
			if(ppCellAry[i]!=NULL)
				delete ppCellAry[i];
		}
		delete[] ppCellAry;
	}

	// `4ؔz\z
	bool Init( unsigned int Level, float left, float top, float right, float bottom )
	{
		// ݒōxȏ̋Ԃ͍Ȃ
		if(Level>=CLINER4TREEMANAGER_MAXLEVEL)
			return false;

		// exł̋ԐZo
		int i;
		m_iPow[0] = 1;
		for(i=1;i<CLINER4TREEMANAGER_MAXLEVEL+1;i++)
			m_iPow[i] = m_iPow[i-1]*4;

		// Levelxi0_j̔z쐬
		m_dwCellNum = (m_iPow[Level+1]-1)/3;
		ppCellAry = new CCell<T>*[m_dwCellNum];
		ZeroMemory( ppCellAry, sizeof(CCell<T>*)*m_dwCellNum );

		// ̈o^
		m_fLeft = left;
		m_fTop = top;
		m_fW = right - left;
		m_fH = bottom - top;
		m_fUnit_W = m_fW/(1<<Level);
		m_fUnit_H = m_fH/(1<<Level);

		m_uiLevel = Level;

		return true;
	}

	// IuWFNgo^
	bool Regist( float left, float top, float right, float bottom, sp<OBJECT_FOR_TREE<T> > &spOFT )
	{
		// IuWFNg̋E͈͂o^[gԍZo
		DWORD Elem = GetMortonNumber( left, top, right, bottom );
		if(Elem < m_dwCellNum ){
			// Ԃꍇ͐VK쐬
			if( !ppCellAry[Elem] )
				CreateNewCell(Elem);
			return ppCellAry[Elem]->Push(spOFT);
		}
		return false;	// o^s
	}

	// Փ˔胊Xg쐬
	DWORD GetAllCollisionList( vector<T*> &ColVect )
	{
		// Xgizj͕K܂
		ColVect.clear();

		// [gԂ݂̑`FbN
		if(ppCellAry[0]==NULL)
			return 0;	// Ԃ݂ĂȂ

		// [gԂ
		list<T*> ColStac;
		GetCollisionList( 0, ColVect, ColStac );

		return (DWORD)ColVect.size();
	}



protected:
	// ԓŏՓ˃Xg쐬
	bool GetCollisionList( DWORD Elem, vector<T*> &ColVect, list<T*> &ColStac )
	{
		list<T*>::iterator it;
		// @ ԓ̃IuWFNgm̏Փ˃Xg쐬
		sp<OBJECT_FOR_TREE<T> > spOFT1 = ppCellAry[Elem]->GetFirstObj();
		while( spOFT1.GetPtr()!=NULL)
		{
			sp<OBJECT_FOR_TREE<T> > spOFT2 = spOFT1->m_spNext;
			while(spOFT2!=NULL){
				// Փ˃Xg쐬
				ColVect.push_back(spOFT1->m_pObject);
				ColVect.push_back(spOFT2->m_pObject);
				spOFT2 = spOFT2->m_spNext;
			}
			// A Փ˃X^bNƂ̏Փ˃Xg쐬
			for(it=ColStac.begin(); it!=ColStac.end(); it++){
				ColVect.push_back(spOFT1->m_pObject);
				ColVect.push_back(*it);
			}
			spOFT1 = spOFT1->m_spNext;
		}

		bool ChildFlag = false;
		// B qԂɈړ
		DWORD ObjNum = 0;
		DWORD i, NextElem;
		for(i=0; i<4; i++){ 
			NextElem = Elem*4+1+i;
			if( NextElem<m_dwCellNum && ppCellAry[Elem*4+1+i] ){
				if(!ChildFlag){
					// C o^IuWFNgX^bNɒǉ
					spOFT1 = ppCellAry[Elem]->GetFirstObj();
					while( spOFT1.GetPtr() ){
						ColStac.push_back( spOFT1->m_pObject );
						ObjNum++;
						spOFT1 = spOFT1->m_spNext;
					}
				}
				ChildFlag = true;
				GetCollisionList( Elem*4+1+i, ColVect, ColStac );	// qԂ
			}
		}

		// D X^bNIuWFNgO
		if( ChildFlag ){
			for(i=0; i<ObjNum; i++)
				ColStac.pop_back();
		}

		return true;
	}


	// Ԃ𐶐
	bool CreateNewCell( DWORD Elem )
	{
		// ̗vfԍ
		while( !ppCellAry[Elem] )
		{
			// w̗vfԍɋԂVK쐬
			ppCellAry[Elem] = new CCell<T>;

			// eԂɃWv
			Elem = (Elem-1)>>2;
			if(Elem>=m_dwCellNum) break;
		}
		return true;
	}

	// WԔԍZo
	DWORD GetMortonNumber( float left, float top, float right, float bottom )
	{
		// ŏxɂeʒuZo
		DWORD LT = GetPointElem(left, top);
		DWORD RB = GetPointElem(right, bottom );

		// ԔԍZ
		// ŏʋ؂肩珊xZo
		DWORD Def = RB - LT;
		unsigned int HiLevel = 0;
		unsigned int i;
		for(i=0; i<m_uiLevel; i++)
		{
			DWORD Check = (Def>>(i*2)) & 0x3;
			if( Check != 0 )
				HiLevel = i+1;
		}
		DWORD SpaceNum = RB>>(HiLevel*2);
		DWORD AddNum = (m_iPow[m_uiLevel-HiLevel]-1)/3;
		SpaceNum += AddNum;

		if(SpaceNum > m_dwCellNum)
			return 0xffffffff;

		return SpaceNum;
	}

	// rbg֐
	DWORD BitSeparate32( DWORD n )
	{
		n = (n|(n<<8)) & 0x00ff00ff;
		n = (n|(n<<4)) & 0x0f0f0f0f;
		n = (n|(n<<2)) & 0x33333333;
		return (n|(n<<1)) & 0x55555555;
	}

	// 2D[gԔԍZo֐
	WORD Get2DMortonNumber( WORD x, WORD y )
	{
		return (WORD)(BitSeparate32(x) | (BitSeparate32(y)<<1));
	}

	// W`4ؗvfԍϊ֐
	DWORD GetPointElem( float pos_x, float pos_y )
	{
		return Get2DMortonNumber( (WORD)((pos_x-m_fLeft)/m_fUnit_W), (WORD)((pos_y-m_fTop)/m_fUnit_H) );
	}
};





/////////////////////////////////////
// `8؋ԊǗNX
//////////////////////////////////
#define CLINER8TREEMANAGER_MAXLEVEL		7
template <class T>
class CLiner8TreeManager
{
protected:
	unsigned int m_uiDim;
	CCell<T> **ppCellAry;	// `ԃ|C^z
	unsigned int m_iPow[CLINER8TREEMANAGER_MAXLEVEL+1];	// ׂ搔lz
	D3DXVECTOR3 m_W;	// ̈̕
	D3DXVECTOR3 m_RgnMin;	// ̈̍ŏl
	D3DXVECTOR3 m_RgnMax;	// ̈̍ől
	D3DXVECTOR3 m_Unit;		// ŏ̈̕ӂ̒
	DWORD m_dwCellNum;		// Ԃ̐
	unsigned int m_uiLevel;			// ŉʃx

public:
	// RXgN^
	CLiner8TreeManager()
	{
		m_uiDim = 0;
		ppCellAry = NULL;
		m_W.x = m_W.y = m_W.z = 1.0f;
		m_RgnMin.x = m_RgnMin.y = m_RgnMin.z = 0.0f;
		m_RgnMax.x = m_RgnMax.y = m_RgnMax.z = 1.0f;
		m_Unit.x = m_Unit.y = m_Unit.z = 1.0f;
		m_dwCellNum = 0;
		m_uiLevel = 0;
	}

	// fXgN^
	virtual ~CLiner8TreeManager()
	{
		DWORD i;
		for(i=0; i<m_dwCellNum; i++){
			if(ppCellAry[i]!=NULL)
				delete ppCellAry[i];
		}
		delete[] ppCellAry;
	}

	// `8ؔz\z
	bool Init( unsigned int Level, D3DXVECTOR3 &Min, D3DXVECTOR3 &Max )
	{
		// ݒōxȏ̋Ԃ͍Ȃ
		if(Level>=CLINER8TREEMANAGER_MAXLEVEL)
			return false;

		// exł̋ԐZo
		int i;
		m_iPow[0] = 1;
		for(i=1;i<CLINER8TREEMANAGER_MAXLEVEL+1;i++)
			m_iPow[i] = m_iPow[i-1]*8;

		// Levelxi0_j̔z쐬
		m_dwCellNum = (m_iPow[Level+1]-1)/7;
		ppCellAry = new CCell<T>*[m_dwCellNum];
		ZeroMemory( ppCellAry, sizeof(CCell<T>*)*m_dwCellNum );

		// ̈o^
		m_RgnMin = Min;
		m_RgnMax = Max;
		m_W = m_RgnMax-m_RgnMin;
		m_Unit = m_W/((float)(1<<Level));

		m_uiLevel = Level;

		return true;
	}

	// IuWFNgo^
	bool Regist( D3DXVECTOR3 *Min, D3DXVECTOR3 *Max, sp<OBJECT_FOR_TREE<T> > &spOFT )
	{
		// IuWFNg̋E͈͂o^[gԍZo
		DWORD Elem = GetMortonNumber( Min, Max );
		if(Elem < m_dwCellNum ){
			// Ԃꍇ͐VK쐬
			if( !ppCellAry[Elem] )
				CreateNewCell(Elem);
			return ppCellAry[Elem]->Push(spOFT);
		}
		return false;	// o^s
	}

	// Փ˔胊Xg쐬
	DWORD GetAllCollisionList( vector<T*> &ColVect )
	{
		// Xgizj͕K܂
		ColVect.clear();

		// [gԂ݂̑`FbN
		if(ppCellAry[0]==NULL)
			return 0;	// Ԃ݂ĂȂ

		// [gԂ
		list<T*> ColStac;
		GetCollisionList( 0, ColVect, ColStac );

		return (DWORD)ColVect.size();
	}



protected:
	// ԓŏՓ˃Xg쐬
	bool GetCollisionList( DWORD Elem, vector<T*> &ColVect, list<T*> &ColStac )
	{
		list<T*>::iterator it;
		// @ ԓ̃IuWFNgm̏Փ˃Xg쐬
		sp<OBJECT_FOR_TREE<T> > spOFT1 = ppCellAry[Elem]->GetFirstObj();
		while( spOFT1.GetPtr()!=NULL)
		{
			sp<OBJECT_FOR_TREE<T> > spOFT2 = spOFT1->m_spNext;
			while(spOFT2!=NULL){
				// Փ˃Xg쐬
				ColVect.push_back(spOFT1->m_pObject);
				ColVect.push_back(spOFT2->m_pObject);
				spOFT2 = spOFT2->m_spNext;
			}
			// A Փ˃X^bNƂ̏Փ˃Xg쐬
			for(it=ColStac.begin(); it!=ColStac.end(); it++){
				ColVect.push_back(spOFT1->m_pObject);
				ColVect.push_back(*it);
			}
			spOFT1 = spOFT1->m_spNext;
		}

		bool ChildFlag = false;
		// B qԂɈړ
		DWORD ObjNum = 0;
		DWORD i, NextElem;
		for(i=0; i<8; i++){ 
			NextElem = Elem*8+1+i;
			if( NextElem<m_dwCellNum && ppCellAry[Elem*8+1+i] ){
				if(!ChildFlag){
					// C o^IuWFNgX^bNɒǉ
					spOFT1 = ppCellAry[Elem]->GetFirstObj();
					while( spOFT1.GetPtr() ){
						ColStac.push_back( spOFT1->m_pObject );
						ObjNum++;
						spOFT1 = spOFT1->m_spNext;
					}
				}
				ChildFlag = true;
				GetCollisionList( Elem*8+1+i, ColVect, ColStac );	// qԂ
			}
		}

		// D X^bNIuWFNgO
		if( ChildFlag ){
			for(i=0; i<ObjNum; i++)
				ColStac.pop_back();
		}

		return true;
	}


	// Ԃ𐶐
	bool CreateNewCell( DWORD Elem )
	{
		// ̗vfԍ
		while( !ppCellAry[Elem] )
		{
			// w̗vfԍɋԂVK쐬
			ppCellAry[Elem] = new CCell<T>;

			// eԂɃWv
			Elem = (Elem-1)>>3;
			if(Elem>=m_dwCellNum) break;
		}
		return true;
	}

	// WԔԍZo
	DWORD GetMortonNumber( D3DXVECTOR3 *Min, D3DXVECTOR3 *Max )
	{
		// ŏxɂeʒuZo
		DWORD LT = GetPointElem(*Min);
		DWORD RB = GetPointElem(*Max);

		// ԔԍZ
		// ŏʋ؂肩珊xZo
		DWORD Def = RB ^ LT;
		unsigned int HiLevel = 1;
		unsigned int i;
		for(i=0; i<m_uiLevel; i++)
		{
			DWORD Check = (Def>>(i*3)) & 0x7;
			if( Check != 0 )
				HiLevel = i+1;
		}
		DWORD SpaceNum = RB>>(HiLevel*3);
		DWORD AddNum = (m_iPow[m_uiLevel-HiLevel]-1)/7;
		SpaceNum += AddNum;

		if(SpaceNum > m_dwCellNum)
			return 0xffffffff;

		return SpaceNum;
	}

	// rbg֐
	DWORD BitSeparateFor3D( BYTE n )
	{
		DWORD s = n;
		s = ( s | s<<8 ) & 0x0000f00f;
		s = ( s | s<<4 ) & 0x000c30c3;
		s = ( s | s<<2 ) & 0x00249249;
		return s;
	}

	// 3D[gԔԍZo֐
	DWORD Get3DMortonNumber( BYTE x, BYTE y, BYTE z )
	{
		return BitSeparateFor3D(x) | BitSeparateFor3D(y)<<1 | BitSeparateFor3D(z)<<2;
	}

	// W`8ؗvfԍϊ֐
	DWORD GetPointElem( D3DXVECTOR3 &p )
	{
		return Get3DMortonNumber(
			(BYTE)((p.x-m_RgnMin.x)/m_Unit.x),
			(BYTE)((p.y-m_RgnMin.y)/m_Unit.y),
			(BYTE)((p.z-m_RgnMin.z)/m_Unit.z)
			);
	}
};






/////////////////////////////////////
// ԃNX
//////////////////////////////////
template <class T>
class CCell
{
protected:
	sp<OBJECT_FOR_TREE<T> > m_spLatest;	// ŐVOFLւ̃X}[g|C^

public:
	// RXgN^
	CCell()
	{
	}

	// fXgN^
	virtual ~CCell()
	{
		if(m_spLatest.GetPtr()!=NULL)
			ResetLink(m_spLatest);
	}

	// NSăZbg
	void ResetLink( sp<OBJECT_FOR_TREE<T> > &spOFT )
	{
		if(spOFT->m_spNext.GetPtr()!=NULL)
			ResetLink(spOFT->m_spNext);
		spOFT.SetPtr(NULL);		// X}[g|C^Zbg		
	}

	// OFTvbV
	bool Push( sp<OBJECT_FOR_TREE<T> > &spOFT )
	{
		if(spOFT.GetPtr()==NULL) return false;	// IuWFNg͓o^Ȃ
		if(spOFT->m_pCell==this) return false;	// 2do^`FbN
		if(m_spLatest.GetPtr()==NULL){
			m_spLatest = spOFT;	// ԂɐVKo^
		}
		else
		{
			// ŐVOFTIuWFNgXV
			spOFT->m_spNext = m_spLatest;
			m_spLatest->m_spPre = spOFT;
			m_spLatest = spOFT;
		}
		spOFT->RegistCell( this );	// Ԃo^
		return true;
	}

	sp<OBJECT_FOR_TREE<T> > &GetFirstObj()
	{
		return m_spLatest;
	}

	// 폜IuWFNg`FbN
	bool OnRemove( OBJECT_FOR_TREE<T> *pRemoveObj )
	{
		if(m_spLatest.GetPtr()==pRemoveObj){
			// ̃IuWFNgɑ}ւ
			if(m_spLatest.GetPtr()!=NULL)
				m_spLatest = m_spLatest->GetNextObj();
		}
		return true;
	}
};


}  // end namespace IKD