// `8؏Փ˔TvvO
//   : IKD
//   ~`ǂƃRihttp://www.h6.dion.ne.jp/~game296o/j

#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")

#include <math.h>
#include <windows.h>
#include <tchar.h>
#include <d3d9.h>
#include <d3dx9.h>
#include "CollisionAPI.h"	// Փ˔API
#include "ColTrees.h"	// ؏Փ˃wb_[
#include <time.h>

using namespace std;
using namespace IKD;


_TCHAR gName[100] = _T("`8؏Փ˔TvvO");


///////////////////////////////////////////////
// O[oϐQilςėVׂ܂j
////////////////
float g_Circle_Ref = 0.75f;	// m̔W
float Wall_Ref = 0.78f;		// ƕǂ̔W
int g_PartitionLebel = 6;		// ԕx
float g_Gravity = 9.8f;			// d
const int g_SphereNum = 500;		// 鋅̐
bool g_XLeft  = true;	// X
bool g_XRight = true;	// XE
bool g_ZFar   = true;	// Z
bool g_ZNear  = true;	// ZO
bool g_WindowMode = false;	// EBhE[h/tXN[؂ւ


//
struct SPHERE
{
	DWORD ID;
	D3DXVECTOR3 p;			// ̈ʒu
	D3DXVECTOR3 Pre_p;		// 1Ỏ~̈ʒu
	D3DXVECTOR3 v;			// xxNg
	D3DXVECTOR3 a;			// xxNg
	float r;				// a
	float w;				// 
	float scale;			// XP[

	SPHERE()
	{
		p.x = p.y = p.z = 0.0f;
		Pre_p.x = Pre_p.y = Pre_p.z = 0.0f;
		v.x = v.y = v.z = 0.0f;
		a.x = a.y = a.z = 0.0f;
		r = 1.0f;
		w = 1.0f;
		scale = 1.0f;
	}
};


// ǂƋ̔˃xNgvZ
void GetRefrectVelo(D3DXVECTOR3 *pOut, D3DXVECTOR3 &N, D3DXVECTOR3 &V, float e)
{
	D3DXVec3Normalize(&N,&N);
	*pOut = V - (1+e)*D3DXVec3Dot(&N,&V)*N;
}


// ǂƂ̔ˌ̈ʒuZo
void GetRelectedPos( float Res_time, SPHERE &s, D3DXVECTOR3 &RefV )
{
	// Փˈʒu
	// 0.99͕ǂɂ߂荞܂Ȃ߂̕␳
	s.p = s.Pre_p + s.v * (1-Res_time)*0.99f;
	// ˃xNg
	s.v = RefV;
	// ʒu␳
	s.p += s.v * Res_time;
}



// 2Փˏ
void SphereColProc( SPHERE *s1, SPHERE *s2 )
{
	float t=0;
	D3DXVECTOR3 C1ColPos, C2ColPos, C1Velo, C2Velo;

	// Փ˂Ă2~̏Փˈʒuo
	if(!CheckParticleCollision(
		s1->r, s2->r,
		&s1->Pre_p, &s1->p,
		&s2->Pre_p, &s2->p,
		&t,
		&C1ColPos,
		&C2ColPos))
		return;	// Փ˂ĂȂ悤ł

	// ՓˈʒuOʒuƂĕۑ
	s1->p = C1ColPos;
	s2->p = C2ColPos;
	s1->Pre_p = C1ColPos;
	s2->Pre_p = C2ColPos;

	// Փˌ̑xZo
	if(!CalcParticleColliAfterPos(
		&C1ColPos, &s1->v,
		&C2ColPos, &s2->v,
		s1->w, s2->w,
		g_Circle_Ref, g_Circle_Ref,		// ̔W
		t,
		&C1ColPos, &C1Velo,
		&C2ColPos, &C2Velo))
		return; // s悤ł

	// ՓˌʒuɈړ
	s1->v = C1Velo;
	s2->v = C2Velo;
	s1->p += s1->v;
	s2->p += s2->v;
}


// ̋̈ʒu擾
void GetNextSpherePos( SPHERE &s )
{
	D3DXVECTOR3 RefV;	// ˌ̑xxNg
	D3DXVECTOR3 ColliPos;	// Փˈʒu
	float Res_time = 0.0f;	// Փˌ̈ړ\

	// d͂|ėƂ
	s.v.y -= g_Gravity/60;	// 1t[9.8/60(m/s)

	// ̑xňʒuXV
	s.Pre_p = s.p;		// Öʒuۑ
	s.p += s.v;			// ʒuXV

	// ǂƂ̏Փ˂`FbN
	// X
	if(s.p.x<s.r && g_XLeft){
		// ˌ̑xxNg擾
		GetRefrectVelo( &RefV, D3DXVECTOR3(1,0,0), s.v, Wall_Ref);
		// c莞ԎZo
		Res_time = (s.p.x-s.r) / s.v.x;
		// ˌ̈ʒuZo
		GetRelectedPos(	Res_time, s, RefV );
	}
	// XE
	else if(s.p.x>640-s.r && g_XRight){
		GetRefrectVelo( &RefV, D3DXVECTOR3(-1,0,0), s.v, Wall_Ref);
		Res_time = (s.p.x-640+s.r) / s.v.x;
		GetRelectedPos(	Res_time, s, RefV );
	}
	// ZO
	if(s.p.z<s.r && g_ZNear){
		GetRefrectVelo( &RefV, D3DXVECTOR3(0,0,1), s.v, Wall_Ref);
		Res_time = (s.p.z-s.r) / s.v.z;
		GetRelectedPos(	Res_time, s, RefV );
	}
	// Z
	else if(s.p.z>640-s.r && g_ZFar){
		GetRefrectVelo( &RefV, D3DXVECTOR3(0,0,-1), s.v, Wall_Ref);
		Res_time = (s.p.z-640+s.r) / s.v.z;
		GetRelectedPos(	Res_time, s, RefV );
	}
	// Y
	else if(s.p.y<s.r){
		GetRefrectVelo( &RefV, D3DXVECTOR3(0,1,0), s.v, Wall_Ref);
		Res_time = (s.p.y-s.r) / s.v.y;
		GetRelectedPos(	Res_time, s, RefV );
	}
}


// EBhEvV[W
LRESULT CALLBACK WndProc(HWND hWnd, UINT mes, WPARAM wParam, LPARAM lParam){
	switch(mes){
		case WM_DESTROY: PostQuitMessage(0); return 0;
		case WM_CHAR: if((TCHAR)wParam == VK_ESCAPE) PostQuitMessage(0); return 0;
	}
	return DefWindowProc(hWnd, mes, wParam, lParam);
}



// C֐
int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);	// [N`FbN
	srand((unsigned int)time(NULL));	// ď

	// AvP[V̏
	MSG msg; HWND hWnd;
	WNDCLASSEX wcex ={sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, hInstance, NULL, NULL,
									(HBRUSH)(COLOR_WINDOW+1), NULL, (_TCHAR*)gName, NULL};
	if(!RegisterClassEx(&wcex))
		return 0;

	DWORD WndStyle = WS_OVERLAPPEDWINDOW & ~(WS_MAXIMIZEBOX | WS_SIZEBOX);
	RECT WndRect={0, 0, 640, 480};
	AdjustWindowRect( &WndRect, WndStyle, false );

	if(!(hWnd = CreateWindow( gName, gName, WndStyle, CW_USEDEFAULT, 0,
	   WndRect.right-WndRect.left, WndRect.bottom-WndRect.top, NULL, NULL, hInstance, NULL)))
		return 0;

	// Direct3D̏
	LPDIRECT3D9 g_pD3D;
	LPDIRECT3DDEVICE9 g_pD3DDev;
	if( !(g_pD3D = Direct3DCreate9( D3D_SDK_VERSION )) ) return 0;

	D3DPRESENT_PARAMETERS d3dpp = {800,600,D3DFMT_A8R8G8B8,0,D3DMULTISAMPLE_NONE,0,D3DSWAPEFFECT_DISCARD,hWnd,g_WindowMode,TRUE,D3DFMT_D24S8,0,D3DPRESENT_RATE_DEFAULT,D3DPRESENT_INTERVAL_DEFAULT}; 

	if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, D3DCREATE_HARDWARE_VERTEXPROCESSING, &d3dpp, &g_pD3DDev ) ) )
	if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, &d3dpp, &g_pD3DDev ) ) )
	{
		MessageBox(NULL,_T("DirectX̏Ɏs܂"),NULL,NULL);
		g_pD3D->Release();
		return 0;
	}

	//////////////////////////////
	// ǐ
	////////////
	ID3DXBuffer *pWallMaterials;
	DWORD NumWallMaterials;
	ID3DXMesh *pWallMesh;
	if(FAILED(D3DXLoadMeshFromX( _T("Wall.x"), D3DXMESH_MANAGED, g_pD3DDev, NULL, &pWallMaterials, NULL, &NumWallMaterials, &pWallMesh))){
		g_pD3DDev->Release(); g_pD3D->Release(); return 0;
	}


	//////////////////////////////
	// IuWFNg
	ID3DXBuffer *pMaterials;
	DWORD NumMaterials;
	ID3DXMesh *pMesh;
	if(FAILED(D3DXLoadMeshFromX( _T("Ball.x"), D3DXMESH_MANAGED, g_pD3DDev, NULL, &pMaterials, NULL, &NumMaterials, &pMesh))){
		g_pD3DDev->Release(); g_pD3D->Release(); return 0;
	}

	/////////////////////////////
	// IuWFNg̏
	SPHERE SAry[ g_SphereNum ];
	sp<OBJECT_FOR_TREE<SPHERE> > spSOFTAry[g_SphereNum];	// IuWFNgOFTIuWFNg

	//////////////////////////////////////////
	// IuWFNg̏ʒuEx̐ݒ
	//  Vԃ|Cgł(^-^)
	//////////
	int cn;
	for(cn=0;cn<g_SphereNum;cn++)	// g_SphereNum𐶐
	{
		SAry[cn].ID = cn;
		SAry[cn].r = 5 + 4 *(float)rand()/RAND_MAX;	// ̔a
		SAry[cn].p.x = 42 + 30.5f*(float)rand()/RAND_MAX;		// גʒu
		SAry[cn].p.y = 10 + 800*(float)cn/g_SphereNum;	// \Ƃ납痎Ƃ܂
		if ( cn % 2 )
			SAry[cn].p.z = 11 + 30.5f*(float)rand()/RAND_MAX;
		else
			SAry[cn].p.z = 550 + 30.5f*(float)rand()/RAND_MAX;
		SAry[cn].v.x = 0.0;		// iKj
		SAry[cn].v.y = 0.0;//-cn/80.0f;
		if ( cn % 2 )
			SAry[cn].v.z = -0.0f;
		else
			SAry[cn].v.z = 0.0f;
		SAry[cn].scale = SAry[cn].r;	// 摜64~64Ȃ̂ŃXP[l͂Ȃ܂
		SAry[cn].w = SAry[cn].r*SAry[cn].r*SAry[cn].r;	// ʂ͔a3ɔƂ܂
		// OFTɓo^
		OBJECT_FOR_TREE<SPHERE> *p = new OBJECT_FOR_TREE<SPHERE>;
		p->m_pObject = &SAry[cn];	// o^
		spSOFTAry[cn].SetPtr(p);
	}

	///////////////////////////////////
	// `8؃}l[W
	//  Ԕ͈͂X=-60`720; Y=-60`1200; Z=-60`720ɐݒ
	//  яoȂ͈͂w肷Ηǂ̂
	//  AoEgł
	CLiner8TreeManager<SPHERE> L8Tree;
	if(!L8Tree.Init(
		g_PartitionLebel,
		D3DXVECTOR3(-60, -60, -60),
		D3DXVECTOR3(720, 1200, 720)))
	{
		MessageBox(NULL,_T("`8؋Ԃ̏Ɏs܂B"),NULL,NULL);
		return 0;
	}


	///////////////////////
	// foCXݒ֘A
	//////////
	D3DXMATRIX World;          // ̃[hϊs
	D3DXMATRIX Rot_X, Rot_Y;   // ]s
	D3DXMATRIX Offset;         // ItZbgs
	D3DXMATRIX View;   // r[ϊs
	D3DXMATRIX Persp;   // ˉeϊs
	D3DCOLORVALUE MAmbient = {1.0f, 1.0f, 0.0f, 1.0f};   // }eÃArGg˗

	// ˉeϊ
	D3DXMatrixPerspectiveFovLH( &Persp, D3DXToRadian(45), 640.0f/480.0f, 1.0f, 10000.0f);
	g_pD3DDev->SetRenderState(D3DRS_NORMALIZENORMALS, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_SHADEMODE, D3DSHADE_GOURAUD);

	// Cg
	D3DLIGHT9 light;
	ZeroMemory(&light, sizeof(D3DLIGHT9) );
	light.Direction = D3DXVECTOR3(-3, -1, -2);
	light.Type = D3DLIGHT_DIRECTIONAL; 
	light.Diffuse.r = 1.0f;
	light.Diffuse.g = 1.0f;
	light.Diffuse.b = 1.0f;
	light.Ambient.r = 0.0f;
	light.Ambient.g = 0.0f;
	light.Ambient.b = 0.0f;
	light.Range = 1000;

	g_pD3DDev->SetLight( 0, &light );
	g_pD3DDev->LightEnable( 0, true );
	g_pD3DDev->SetRenderState( D3DRS_LIGHTING, TRUE );
	g_pD3DDev->SetRenderState( D3DRS_AMBIENT, 0x00101010 );

	// EBhE\
	ShowWindow( hWnd, SW_SHOW );

	// [vꎞϐ
	DWORD ColNum;				// Փ˔
	vector<SPHERE*> ColVect;	// ՓˑΏۃXg
	TCHAR pText[64];
	int cnt=0;
	HDC hDC = GetDC(hWnd);
	D3DCOLORVALUE Color01 = {1.0f, 0.3f, 0.0f, 1.0f};
	D3DCOLORVALUE Color02 = {0.0f, 0.5f, 1.0f, 1.0f};
	do{
		cnt++;
		if( PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) ){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		g_pD3DDev->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(60,80,90), 1.0f, 0 );
		g_pD3DDev->BeginScene();

		// ̈ʒuXVăc[ɍēo^
		for(cn=0;cn<g_SphereNum;cn++)
		{
			SPHERE *pTmp = spSOFTAry[cn]->m_pObject;
			GetNextSpherePos(*pTmp);	// ̈ړʒu
			spSOFTAry[cn]->Remove();		// xXgO
			// ēo^
			D3DXVECTOR3 tmpMin(pTmp->p.x-pTmp->r, pTmp->p.y-pTmp->r, pTmp->p.z-pTmp->r);
			D3DXVECTOR3 tmpMax(pTmp->p.x+pTmp->r, pTmp->p.y+pTmp->r, pTmp->p.z+pTmp->r);
			L8Tree.Regist( &tmpMin, &tmpMax, spSOFTAry[cn] );
		}

		// ՓˑΉXg擾
		ColNum = L8Tree.GetAllCollisionList( ColVect );

		// Փ˔
		DWORD c;
		ColNum/=2;	// 2Ŋ̂̓yAɂȂĂ̂
		for(c=0; c<ColNum; c++){
			float r2 = (ColVect[c*2]->r+ColVect[c*2+1]->r)*(ColVect[c*2]->r+ColVect[c*2+1]->r);
			float x = (ColVect[c*2]->p.x-ColVect[c*2+1]->p.x);
			float y = (ColVect[c*2]->p.y-ColVect[c*2+1]->p.y);
			float z = (ColVect[c*2]->p.z-ColVect[c*2+1]->p.z);
			if(r2 >= x*x + y*y + z*z)
			{
				// 2Փˏ
				SphereColProc( ColVect[c*2], ColVect[c*2+1] );
			}
		}

		//////////////
		// J
		////
		D3DXMatrixLookAtLH(
			&View,
			&D3DXVECTOR3( 700*cos(cnt/500.0f), 200, 100*sin(cnt/400.0f)),
			&D3DXVECTOR3(100, 0, 320),
			&D3DXVECTOR3(0, 1, 0)
		);

		////////////////
		// `
		//////
		// so^
		g_pD3DDev->SetTransform(D3DTS_VIEW, &View);
		g_pD3DDev->SetTransform(D3DTS_PROJECTION, &Persp);

		for(cn=0; cn<g_SphereNum; cn++){
			D3DXMatrixIdentity( &World );   // ͌_ɈʒûŒPʍs
			World._11 = SAry[cn].scale;
			World._22 = SAry[cn].scale;
			World._33 = SAry[cn].scale;
			World._41 = SAry[cn].p.x;
			World._42 = SAry[cn].p.y;
			World._43 = SAry[cn].p.z;
			g_pD3DDev->SetTransform(D3DTS_WORLD, &World);
			DWORD i;
			for(i=0; i<NumMaterials; i++){
				D3DXMATERIAL *mtrl = ( (D3DXMATERIAL*)(pMaterials->GetBufferPointer()));
				mtrl[i].MatD3D.Ambient = MAmbient;
				mtrl[i].MatD3D.Diffuse = cn % 2 ? Color01 : Color02;
				g_pD3DDev->SetMaterial( &mtrl[i].MatD3D );
				pMesh->DrawSubset(i);
			}
		}

		////////////////
		// Ǖ`
		//////
		D3DXMatrixIdentity( &World );   // ͌_ɈʒûŒPʍs
		g_pD3DDev->SetTransform(D3DTS_WORLD, &World);
		DWORD i;
		for(i=0; i<NumWallMaterials; i++){
			D3DXMATERIAL *mtrl = ( (D3DXMATERIAL*)(pWallMaterials->GetBufferPointer()));
			mtrl[i].MatD3D.Ambient = MAmbient;
			g_pD3DDev->SetMaterial( &mtrl[i].MatD3D );
			pWallMesh->DrawSubset(i);
		}

		g_pD3DDev->EndScene();
		g_pD3DDev->Present( NULL, NULL, NULL, NULL );

		// c[\
		_stprintf_s(pText, _T("Sphere Number = %d"), g_SphereNum);
		TextOut(hDC, 0, 22, pText, (int)_tcslen(pText) );
		_stprintf_s(pText, _T("Collision Check Number = %d"), ColNum/2);
		TextOut(hDC, 0, 44, pText, (int)_tcslen(pText) );
		_stprintf_s(pText, _T("Optimaization = %2.5f "), 100.0*(float)(ColNum/2)/(g_SphereNum/2*(g_SphereNum+1)));
		TextOut(hDC, 0, 66, pText, (int)_tcslen(pText) );
		_stprintf_s(pText, _T("Counter = %d"), cnt);
		TextOut(hDC, 0, 88, pText, (int)_tcslen(pText) );
	}while(msg.message != WM_QUIT);

	ReleaseDC(hWnd, hDC);
	pWallMaterials->Release();
	pWallMesh->Release();
	pMaterials->Release();
	pMesh->Release();
	g_pD3DDev->Release();
	g_pD3D->Release();

	return 0;
}


